function mF_all = EvalField(vSol, pos, oGd, k, beta, sComponent, mX, mY, isImproper)
global EPSILON0 MU0 C DELTA ETA
if isreal(beta)
    isImproper = 0;
end
bCancel = 0;
w = k*C;
Z = j*w*MU0;
vISources = [0 cumsum(2*[pos.sources.n])];
sdArray = oGd.sdArray;
mF_all = zeros(size(mX));
pd = 0; %percent done;
sComponent_latex = ['$' upper(sComponent(1)) '_' lower(sComponent(2)) '$'];
hWaitbar = waitbar(pd,['Plotting ' sComponent_latex ' field...'], 'CreateCancelBtn', @cancel_callback, 'visible', 'off');
hFig = findobj('tag', 'uiSmtgui');
if ~isempty(hFig)
    set(hWaitbar, 'color', get(hFig, 'color'));
end
set(hWaitbar, 'visible', 'on')
if isfield(oGd, 'hGreenFun')
    hGreenFun = oGd.hGreenFun;
else
    hGreenFun = @green_fun;
end
mB_all = zeros(size(mX));
for iSd = 1:oGd.nSd
    if pos.sources(iSd).n == 0
        continue
    end
    vSd = pos.sources(iSd).iSd;
    for indVsd = 1:length(vSd)
        % iSd_sources points to the sd from which the source for
        % this sd should be taken
        iSd_sources = vSd(indVsd);
        sd = sdArray(iSd);
        Er = sd.Er;
        if ischar(Er)
            Er = feval(Er, 2*pi/k);
        end
        Y = j*EPSILON0*Er*w;
        ETA_sd2 = Z/Y;
        kc = calc_kc(k, beta, Er, isImproper);
        isImproper = 0; % After the first region, all regions should be proper
        vX = pos.sources(iSd_sources).vX;
        vY = pos.sources(iSd_sources).vY;
        first_magnetic = vISources(iSd_sources);
        first_electric = first_magnetic+pos.sources(iSd_sources).n;
        mF = zeros(size(mX));
        mB = in_subdomain(mX, mY, sd) & ~mB_all;
        mB_all = mB_all | mB;
        mX_sd = mX(mB);
        mY_sd = mY(mB);
        if isempty(mX_sd) | isempty(mY_sd)
            continue
        end
        for ii = 1:length(vX)
            if bCancel
                mF_all = NaN;
                return
            end
            pd = pd + 1;
            waitbar(pd/vISources(end)*2, hWaitbar);
            evalat.vX = mX_sd;
            evalat.vY = mY_sd;
            sources.x = vX(ii);
            sources.y = vY(ii);
            sources.vGreen = pos.sources(iSd_sources).vGreen;
            [mFiiJ, mFiiM] = feval(hGreenFun, evalat, sources, Y, kc, beta, oGd, sComponent);
            mF(mB) = mF(mB) + mFiiJ*vSol(first_electric+ii) + mFiiM*vSol(first_magnetic+ii)*ETA;
        end
    end
    mF_all(mB) = mF_all(mB) + mF(mB);
end

close(hWaitbar)
%if lower(sComponent(1)) == 'h'
%    mF_all = mF_all/ETA;
%end

    function cancel_callback(varargin)
        bCancel = 1;
        delete(gcf)
    end
end