clear
clf
smt_init

load -mat mcphedran.gd

lambda = 1.45e-6;
k0 = 2*pi/lambda;
positions = distribute(oGd);
method = 'direct';

Neff = (1.44539); % the fundamental mode
[error, solution] = smt_solve(Neff, oGd, positions, k0, method);
error
points = 50;
[maxX, minX, maxY, minY] = oGdRange(oGd);
a = 1.5; % enlarge calculation window by factor: a
x = linspace(minX*a, maxX*a, points);
y = linspace(minY*a, maxY*a, points);
[neff_i, Sz] = calc_att(solution, positions, oGd, k0, Neff, x, y);
neff_i
imagesc(x, y, abs(Sz))
axis image
colorbar
draw_geom(oGd, 'noaxischange')
colormap pink