function cs_out = cs_dist(vein, d)
xc = vein.xc;
yc = vein.yc;
max_x = vein.max_x+xc;
min_x = vein.min_x+xc;
max_y = vein.max_y+yc;
min_y = vein.min_y+yc;
if d > 0
    D = 1.1*d;
else
    D = (max_x-min_x)/10;
end
max_x = max_x+D;
min_x = min_x-D;
max_y = max_y+D;
min_y = min_y-D;
r = min_feature(vein.cs);
pointsx = (max_x-min_x)/r*5;
pointsy = (max_y-min_y)/r*5;
x = linspace(min_x, max_x, pointsx);
y = linspace(min_y, max_y, pointsy);
[mX, mY] = meshgrid(x,y);
mB = in_shape(mX, mY, xc, yc, vein);
if d < 0
    mB = 1-mB;
end
cnt = contourc(x, y, bwdist(mB), abs([d d])./(max_x-min_x)*pointsx);
frac = 0.06;
iCnt = find(cnt(1,:) == abs(d)/(max_x-min_x)*pointsx);
for iiCnt = 1:length(iCnt) 
    iStart = iCnt(iiCnt)+1;
    pairs = cnt(2,iStart-1);
    iEnd = iStart + pairs-1;
    xi = cnt(1, iStart:iEnd);
    yi = cnt(2, iStart:iEnd);
    L = length(xi);
    ind = round(linspace(1, L, round(frac*L)));
    xi = xi(ind);
    yi = yi(ind);
    pairs = [xi; yi];
    cs_out(iiCnt) = cscvn(pairs);
end
%N = 500; 
%vT = linspace(cs_out.breaks(1), cs_out.breaks(end), N);
%mF = ppval(cs_out, vT);
%xline = mF(1,:);
%yline = mF(2,:);
%imagesc(x,y,mB);
%hold
%plot(xi, yi, 'r.', xline, yline, 'b', 'linewidth', 2)
