% make two touching step-index fibers
V = 3.5;
lambda = 0.6328e-6;
n2 = 1.457;
n1 = n2/sqrt(0.9);
R1 = V*lambda/(2*pi)/sqrt(n1^2-n2^2);
R2 = R1/1.3;
vCx = [0 (R1+R2)];
vCy = [0 0];
oGd.nSources = 30*2;
oGd.nTestingPoints = oGd.nSources*1.5;
oGd.alphaIn = 0.5;
oGd.alphaOut = 0.5;
oGd.offsetX = (R1+R1)/2;
oGd.offsetY = 0;
curve1 = primitive('circle', R1);
curve2 = primitive('circle', R2);
curve1.xc = vCx(1);
curve2.xc = vCx(2);
curve1.yc = vCy(1);
curve2.yc = vCy(2);
curveArray = array_cat(curve1, curve2);

oGd.curveArray = curveArray;
oGd.sdArray = compute_sd_array(curveArray);
oGd.nSd = length(oGd.sdArray);
vEr = [n2^2, n1^2*ones(1, oGd.nSd-1)];
for iSd = 1:oGd.nSd
    oGd.sdArray(iSd).Er = vEr(iSd);
end
oGd = orderfields(oGd);
save -mat touching.gd
