% find a non_trivial solution to A*x = 0;
function [err,sol] = non_trivial(mZ, mBNegate, sMethod, varargin)
warning off MATLAB:nearlySingularMatrix
warning off MATLAB:eigs:SigmaNearExactEig
if ~isempty(varargin{:})
    v0 = varargin{:};
else
    v0 = [];
end
if strcmpi(sMethod, 'direct')
    A = mZ'*mZ;
    tol = 1e-4/norm(A,1);
    mZ(mBNegate) = -mZ(mBNegate);
    B = mZ'*mZ;
    
    B = (B+B')/2;
    A = (A+A')/2;
    [sol, err] = my_eigs(A, B, tol, v0);
else
    use_gsvd
end
warning on MATLAB:nearlySingularMatrix
warning on MATLAB:eigs:SigmaNearExactEig
err= sqrt(abs(err));

    function use_gsvd
        mZ1 = mZ;
        mZ1(mBNegate) = -mZ1(mBNegate);
        [U,V,X,C,S] = gsvd(mZ,mZ1);
        [err, ind] =  min(abs(diag(C)./diag(S)));
        err = err^2;
        X1 = X'\eye(size(X'));
        sol = X1(:,ind);
    end

end