% find a non_trivial solution to A*x = 0;
function [err,sol] = non_trivial_filtered(mZ, mBNegate, mSol_filter, min_err, varargin)
warning off MATLAB:nearlySingularMatrix
warning off MATLAB:eigs:SigmaNearExactEig

if ~isempty(varargin{:})
    v0 = varargin{:};
else
    v0 = [];
end
A = mZ'*mZ;
tol = (1e-4/norm(A,1))^2;
mZ(mBNegate) = -mZ(mBNegate);
B = mZ'*mZ;
[r,nModes] = size(mSol_filter);
for iMode = 1:nModes
    vSol_filter = mSol_filter(:,iMode);
    delta = (B*vSol_filter*vSol_filter'*B')/(vSol_filter'*B'*vSol_filter)*min_err;
    A = A+delta;
end
B = (B+B')/2;
A = (A+A')/2;
[sol, err] = my_eigs(A, B, tol, v0);

err= sqrt(abs(err));
warning on MATLAB:nearlySingularMatrix
warning on MATLAB:eigs:SigmaNearExactEig