function oOut = simple_shape(tag, nPoints, param)
phi = linspace(0, 2*pi - 2*pi/nPoints, nPoints);
phi = phi+pi/nPoints;
switch lower(tag)
    case 'circle'
        R = param(1);
        x = cos(phi)*R;
        y = sin(phi)*R;
        oOut.tag = tag;
        oOut.x = x;
        oOut.y = y;
        oOut.vNx = x/R;
        oOut.vNy = y/R;
        return
    case 'ellipse'
        R = param(1);
        ell = param(2);
        x = cos(phi)*R;
        y = ell*sin(phi)*R;
        m = -ell*cot(phi);
end
vNx = -m./sqrt(1+m.^2);
vNy = 1./sqrt(1+m.^2);
[dummy, nan_ind] = find(isnan(vNx)+isnan(vNy));
vNx(nan_ind) = 1;
vNy(nan_ind) = 0;
tips_x = x+R*vNx/3;
tips_y = y+R*vNy/3;
inv_tips_x = x-R*vNx/3;
inv_tips_y = y-R*vNy/3;
tips_r = sqrt(tips_x.^2+tips_y.^2);
inv_tips_r = sqrt(inv_tips_x.^2+inv_tips_y.^2);
vSign = (tips_r>inv_tips_r)*2-1;
vNx = vSign.*vNx;
vNy = vSign.*vNy;

oOut.tag = tag;
oOut.x = x;
oOut.y = y;
oOut.vNx = vNx;
oOut.vNy = vNy;