clear
clf
smt_init

a = 141*1e-9;
d = 500e-9;
ell = 1;
Er = 2.29;
oGd = make_nanowire(a, d, ell, Er);

lambda = 0.633e-6;

k0 = 2*pi/lambda;
%sClass = 'p1';
%oGd.hGreenFun = @green_fun;
positions = distribute(oGd);
%positions = cut_pos(oGd, positions, sClass);

neff_r = 1.0917417027;
neff_i = 0.001;
points_r = 1; % number of samples on the real axis
delta = 0.001;
delta = 0;
min_Neff_r = neff_r-delta;
max_Neff_r = neff_r+delta;

% imaginary part of Neff
min_Neff_i = max(neff_i-delta, 0);
max_Neff_i = (neff_i+delta)/100;
min_Neff_i = 0;
max_Neff_i = 0.001;
points_i = points_r*(max_Neff_i-min_Neff_i)/(max_Neff_r-min_Neff_r);
points_i = 30;
points = points_r*points_i;
Neff_r = linspace(min_Neff_r, max_Neff_r, points_r);
Neff_i = linspace(min_Neff_i, max_Neff_i, points_i);
isImproper = 0; % find bound modes, not leaky modes.
acc = zeros(round(points_i), points_r); % Accuracy function

tic
for ir = 1:points_r
    for ii = 1:points_i
        Neff = Neff_r(ir)-j*Neff_i(ii);
        error = smt_solve(Neff, oGd, positions, k0, isImproper);
        acc(ii,ir) = 1/error;

        fraction_done = ((ir-1)*points_i+ii)/points;
        fprintf(1, 'percent done: %d\n', round(fraction_done*100))
        t = toc;
        fprintf(1,'minutes to go: %6.2f\n', (1-fraction_done)/fraction_done*t/60)
        if length(Neff_i) == 1
            plot(Neff_r(1:ir), acc(1,1:ir),'r-', Neff_r(1:ir), acc(1,1:ir), 'k*')
            axis tight
            grid
            drawnow
            continue
        end
        if length(Neff_r) == 1
            plot(Neff_i(1:ii), acc(1:ii,1),'r-', Neff_i(1:ii), acc(1:ii,1), 'k*')
            axis tight
            grid
            drawnow
            continue
        end
        imagesc(Neff_r, Neff_i, acc);
        set(gca,'ydir','normal')
        colorbar
        axis image
        drawnow
    end
    pause(0.1) % To allow CTRL-C to stop the loop
end
%%
[r,c] = m_max(acc);
fprintf(1,'maximum at:\nneff_r = %6.10f\nneff_i = %6.10f\n', Neff_r(c), Neff_i(r))